HDU 2451 Simple Addition Expression(组合数学)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2451

Problem Description

A luxury yacht with 100 passengers on board is sailing on the sea in the twilight. The yacht is ablaze with lights and there comes out laughers and singing from the hall where an evening party is in full swing. People are singing, dancing and enjoying themselves.

The yacht is equipped with the most advanced navigation and driving system which can all be manipulated by a computer. When the captain notices that there is only gentle breeze and the sea waves are not high, he starts the autopilot. The yacht sails forward
smoothly, ploughs the waves. When it’s completely dark, the passengers start to feel a little funny for sudden forward rushes or sudden decelerations or slight swings. The captain immediately walks to the driving platform and switches the autopilot to human
manipulation. The yacht returns back to normal and the party restarts. Laughers come back, too.

The captain summons the engineer on board to do a thorough check of the navigation system. It turns out that only the computer is out of order, but the exact failure is still unclear. There is a computer scientist among the passengers who is also invited to
the cab to give a hand. He first inputs several groups of data to test the computer. When he inputs 1+2+3, the computer outputs 6, which is exactly right. But when he inputs 4+5+6, the computer outputs 5, which is wrong. Then he inputs 12+13+14, and gets 39,
another right answer, while he inputs 14+15+16, and gets 35, another wrong answer. After the test, the computer scientist says smilingly: “the failure is clear now. The computer‘s adder can not carry." After excluding the failure, the captain restarts the
autopilot and the yacht returns back to normal, sailing smoothly on the sea.

The captain and the engineer invite the computer scientist to sit down and have a talk. The computer scientist tells a story as following:

A former mathematician defined a kind of simple addition expression.

If there is an expression (i) + (i+1) + (i+2), i>=0, when carried out additive operations, no position has a carry, it is called simple addition expression.

For instance, when i equals 0, 0+1+2 is a simple addition expression, meanwhile when i equals 11, 11+12+13 is a simple addition expression, too. Because of that no position has a carry.

However, when i equals 3, 3+4+5 is not a simple addition expression, that is because 3+4+5 equals 12, there is a carried number from unit digit to tens digit. In the same way, when i equals 13, 13+14+15 is not a simple addition expression, either. However,
when i equals 112, 112+113+114 is a simple addition expression. Because 112+113+114 equals 339, there is no carry in the process of adding.

when the students have got the definition of simple addition expression, the mathematician puts forward a new question: for a positive integer n, how many simple addition expressions exist when i<n. In addition, i is the first number of a simple addition expression.

when the value of n is large enough, the problem needs to be solved by means of computer.

Input

There are several test cases, each case takes up a line, there is an integer n (n<10^10).

Output

Output the number of all simple addition expressions when i<n.

Sample Input

1
2
3
4
10
11

Sample Output

1
2
3
3
3
4

Source

2008 Asia Regional Harbin

题意:

对于小于 n 的整数 i 中(i + i+1 + i+2)不会产生进位的一共有多少种。

PS:

最高位满足1,2,3;中间的数要满足0,1,2,3;个位数满足0,1,2;

所以只要找出小于 n 的数满足这个条件的个数;

代码如下:

#include <cstdio>
#include <cstring>
#include <cmath>
typedef __int64 LL;
int main()
{
    char s[17];
    while(~scanf("%s",s))
    {
        LL ans = 0;
        int len = strlen(s);
        int flag = 0;
        for(int i = 0; i < len-1; i++)
        {
            if(s[i] > '3')
            {
                ans += pow(4.0,len-i-1)*3;
                flag = 1;
                break;
            }
            ans += (s[i]-'0')*pow(4.0,len-i-2)*3;
        }
        if(!flag)
        {
            if(s[len-1] > '3')
                ans += 3;
            else
                ans += s[len-1]-'0';
        }
        printf("%I64d\n",ans);
    }
    return 0;
}
时间: 2024-10-25 13:30:11

HDU 2451 Simple Addition Expression(组合数学)的相关文章

HDU 2451 Simple Addition Expression

Simple Addition Expression Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1508    Accepted Submission(s): 576 Problem Description A luxury yacht with 100 passengers on board is sailing on the s

[数位dp] hdu 2451 Simple Addition Expression

题意:给N,求小于N的数中,三个连续的数相加不进位的数有多少个. 思路:和上题类似,就是不是个位的话,可以放0,1,2,3,个位的话只能放0,1,2. 然后就是边界考虑一下,不能超过当前位. 然后就是边界的判断,不是等于len而是等于当前位. 代码: #include"cstdlib" #include"cstdio" #include"cstring" #include"cmath" #include"queue&

HDU 2451 Simple Addition Expression(找规律,考验智商)

题目 最近比赛的题目好多签到题都是找规律的考验智商的题目啊,,,我怎么越来越笨了,,,, 通过列举,可以发现规律: 从左往右按位扫这个数: 当数的长度大于1时: 当首位大于3时,答案就是4*4*4*……*4*3(即pow(4,后面的长度-1)*3): 否则,则是 首位的数字*4*4*4*……*4*3: 当数的长度为1时,并且之前的(即其他的)都没有进位,则直接判断一下ans要加多少个: #include<stdio.h> #include<string.h> #include<

【HDOJ】2451 Simple Addition Expression

递推,但是要注意细节.题目的意思,就是求s(x) = i+(i+1)+(i+2),i<n.该表达中计算过程中CA恒为0(包括中间值)的情况.根据所求可推得.1-10: 31-100: 3*41-1000: 3*4*41-10000: 3*4*4*41-10^n: 3*4^(n-1).并且需要注意,一旦发现某一位大于3,则应立即跳出累加的循环.比如,f(133) = 24,f(143) = 24.同时,单独讨论个位的情况.28行的break处理该种情况. 1 #include <cstdio&g

HDU2451:Simple Addition Expression

Problem Description A luxury yacht with 100 passengers on board is sailing on the sea in the twilight. The yacht is ablaze with lights and there comes out laughers and singing from the hall where an evening party is in full swing. People are singing,

HDU2451 Simple Addition expression(数位dp/找规律)

题意 对于一个非负整数 i, 当 \(i + (i+1) + (i+2)\) 计算过程中不产生进位时,称i满足条件, 求 小于n的 i 的个数. 传送门 思路 数位dp. Code #include <bits/stdc++.h> using namespace std; typedef long long ll; ll dp[20][5], n; int a[20], top; ll dfs(int pos, int sta, bool limit) { if(pos==-1) return

*HDU 2451 数学

Simple Addition Expression Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1723    Accepted Submission(s): 675 Problem Description A luxury yacht with 100 passengers on board is sailing on the s

UVA10994 Simple Addition【前缀和】

Lets define a simple recursive function F(n), where ????Lets define another function S(p, q), ????In this problem you have to Calculate S(p, q) on given value of p and q. Input The input file contains several lines of inputs. Each line contains two n

HDU 4908 BestCoder Sequence(组合数学)

HDU 4908 BestCoder Sequence 题目链接 题意:给定一个序列,1-n的数字,选定一个作为中位数m,要求有多少连续子序列满足中位数是m 思路:组合数学,记录下m左边和右边一共有多少种情况大于m的数字和小于n数组的差,然后等于左边乘右边所有的和,然后最后记得加上左右两边差为0的情况. 当时也是比较逗,还用树状数组去搞了,其实完全没必要 代码: #include <cstdio> #include <cstring> #define lowbit(x) (x&am